﻿@using FIOAPIWeb.PageHelpers.PlanetSearch

<MudTable Dense="true"
          Bordered="true"
          HorizontalScrollbar="true"
          FixedHeader="true"
          FixedFooter="true"
          Hover="true"
          Virtualize="true"
          Breakpoint="Breakpoint.Sm"
          Items="FilteredPlanets"
          RowClass="cursor-pointer"
          @bind-SelectedItem="SelectedPlanet"
          @ref="PlanetDataTable">
    <ToolBarContent>
        <MudText Typo="Typo.h6">Planet Search</MudText>
        <MudMenu Icon="@Icons.Material.Filled.Settings" 
                 Dense="true"
                 Color="Color.Primary"
                 DisableRipple="true"
                 IsOpenChanged="OnOpenChanged">
            <MudMenuItem AutoClose="false">
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowFertility">Fertility</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowSurfaceType">Surface Type</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowGravity">Gravity</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowPressure">Pressure</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTemperature">Temperature</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowLM">Local Market</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowWAR">Warehouse</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowADM">Admin Center</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowSHY">Shipyard</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowCOGC">COGC</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowCurrency">Currency</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalPioneers">Total Pioneers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowUnemployedPioneers">Unemployed Pioneers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalSettlers">Total Settlers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowUnemployedSettlers">Unemployed Settlers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalTechnicians">Total Technicians</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowUnemployedTechnicians">Unemployed Technicians</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalEngineers">Total Engineers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowUnemployedEngineers">Unemployed Engineers</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalScientists">Total Scientists</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowUnemployedScientists">Unemployed Scientists</MudCheckBox>
                <MudCheckBox Dense="true" @bind-Value="PlanetSearchState.ShowTotalPlots">Total Plots</MudCheckBox>
            </MudMenuItem>
        </MudMenu>
        <MudSpacer />
        <MudTextField T="string"
                      @bind-Value="SearchFilter"
                      Immediate="true"
                      Placeholder="Search"
                      Adornment="Adornment.Start"
                      AdornmentIcon="@Icons.Material.Filled.Search"
                      IconSize="Size.Medium"
                      Class="mt-0" />
    </ToolBarContent>
    <HeaderContent>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.DisplayName)">
                Planet
            </MudTableSortLabel>
        </MudTh>
        @if (PlanetSearchState.SelectedMaterials.Count() > 0) 
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Resources.First(r => r.Material == PlanetSearchState.SelectedMaterials[0]).DailyExtraction)">@(PlanetSearchState.SelectedMaterials[0])</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 1)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Resources.First(r => r.Material == PlanetSearchState.SelectedMaterials[1]).DailyExtraction)">@(PlanetSearchState.SelectedMaterials[1])</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 2)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Resources.First(r => r.Material == PlanetSearchState.SelectedMaterials[2]).DailyExtraction)">@(PlanetSearchState.SelectedMaterials[2])</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 3)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Resources.First(r => r.Material == PlanetSearchState.SelectedMaterials[3]).DailyExtraction)">@(PlanetSearchState.SelectedMaterials[3])</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowFertility)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Fertility)">Fertility</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowSurfaceType)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.SurfaceType)">Surface</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowGravity)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Gravity)">Gravity</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowPressure)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Pressure)">Pressure</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTemperature)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.Temperature)">Temp</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowLM)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.HasLocalMarket)">LM</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowWAR)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.HasWarehouse)">WAR</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowADM)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.HasAdministrationCenter)">ADM</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowSHY)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.HasShipyard)">SHY</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowCOGC)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.HasChamberOfCommerce)">COGC</MudTableSortLabel>
            </MudTh>

            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.ActiveCOGCDisplay)">COGC Program</MudTableSortLabel>
            </MudTh>
        }
        @for (int ExchangeIdx = 0; ExchangeIdx < ExchangeLocationNames.Count; ++ExchangeIdx)
        {
            var i = ExchangeIdx; // Capture
            var ExchangeJumpCount = PlanetSearchState.ShowExchangeJumps.Count;
            @if (i < ExchangeJumpCount && PlanetSearchState.ShowExchangeJumps[i])
            {
                <MudTh>
                    <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.DistanceResults[i])">@(ExchangeLocationNames[i].Replace(" Station", ""))</MudTableSortLabel>
                </MudTh>
            }
        }
        @if (PlanetSearchState.ShowCurrency)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.CurrencyCode)">Currency</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalPioneers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalPioneers != null ? x.TotalPioneers : 0)">Total Pioneers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowUnemployedPioneers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.OpenPioneers != null ? x.OpenPioneers : 0)">Unemployed Pioneers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalSettlers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalSettlers != null ? x.TotalSettlers : 0)">Total Settlers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowUnemployedSettlers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.OpenSettlers != null ? x.OpenSettlers : 0)">Unemployed Settlers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalTechnicians)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalTechnicians != null ? x.TotalTechnicians : 0)">Total Technicians</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowUnemployedTechnicians)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.OpenTechnicians != null ? x.OpenTechnicians : 0)">Unemployed Technicians</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalEngineers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalEngineers != null ? x.TotalEngineers : 0)">Total Engineers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowUnemployedEngineers)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.OpenEngineers != null ? x.OpenEngineers : 0)">Unemployed Engineers</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalScientists)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalScientists != null ? x.TotalScientists : 0)">Total Scientists</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowUnemployedScientists)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.OpenScientists != null ? x.OpenScientists : 0)">Unemployed Scientists</MudTableSortLabel>
            </MudTh>
        }
        @if (PlanetSearchState.ShowTotalPlots)
        {
            <MudTh>
                <MudTableSortLabel SortBy="new Func<PlanetSearchModel, object>(x => x.TotalPlots != null ? x.TotalPlots : 0)">Total Plots</MudTableSortLabel>
            </MudTh>
        }
    </HeaderContent>
    <RowTemplate>
        <MudTd DataLabel="Planet">
            @context.DisplayName
        </MudTd>
        @if (PlanetSearchState.SelectedMaterials.Count() > 0)
        {
            <MudTd DataLabel="@(PlanetSearchState.SelectedMaterials[0])">
                @{
                    var DailyExtraction = context.Resources.Where(r => r.Material == PlanetSearchState.SelectedMaterials[0]).Select(r => r.DailyExtraction).FirstOrDefault();
                    if (DailyExtraction > 0.0)
                    {
                        @((DailyExtraction * (ProductionEfficiency / 100.0)).ToString("N2"))
                    }
                }
            </MudTd>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 1)
        {
            <MudTd DataLabel="@(PlanetSearchState.SelectedMaterials[1])">
                @{
                    var DailyExtraction = context.Resources.Where(r => r.Material == PlanetSearchState.SelectedMaterials[1]).Select(r => r.DailyExtraction).FirstOrDefault();
                    if (DailyExtraction > 0.0)
                    {
                        @((DailyExtraction * (ProductionEfficiency / 100.0)).ToString("N2"))
                    }
                }
            </MudTd>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 2)
        {
            <MudTd DataLabel="@(PlanetSearchState.SelectedMaterials[2])">
                @{
                    var DailyExtraction = context.Resources.Where(r => r.Material == PlanetSearchState.SelectedMaterials[2]).Select(r => r.DailyExtraction).FirstOrDefault();
                    if (DailyExtraction > 0.0)
                    {
                        @((DailyExtraction * (ProductionEfficiency / 100.0)).ToString("N2"))
                    }
                }
            </MudTd>
        }
        @if (PlanetSearchState.SelectedMaterials.Count() > 3)
        {
            <MudTd DataLabel="@(PlanetSearchState.SelectedMaterials[3])">
                @{
                    var DailyExtraction = context.Resources.Where(r => r.Material == PlanetSearchState.SelectedMaterials[3]).Select(r => r.DailyExtraction).FirstOrDefault();
                    if (DailyExtraction > 0.0)
                    {
                        @((DailyExtraction * (ProductionEfficiency / 100.0)).ToString("N2"))
                    }
                }
            </MudTd>
        }
        @if (PlanetSearchState.ShowFertility)
        {
            <MudTd DataLabel="Fertility">
                @context.FertilityDisplay
            </MudTd>
        }
        @if (PlanetSearchState.ShowSurfaceType)
        {
            <MudTd DataLabel="Surface">
                @context.SurfaceType
            </MudTd>
        }
        @if (PlanetSearchState.ShowGravity)
        {
            <MudTd DataLabel="Gravity">
                @switch(context.Gravity)
                {
                    case "Low":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Blue.Default};")>Low</MudChip>
                        break;
                    case "High":
                        <MudChip Size="Size.Small"Variant="Variant.Filled" Style=@($"background-color:{Colors.Red.Default};")>High</MudChip>
                        break;
                    case "Normal":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Green.Default};")>Normal</MudChip>
                        break;
                }
                
            </MudTd>
        }
        @if (PlanetSearchState.ShowPressure)
        {
            <MudTd DataLabel="Pressure">
                @switch (context.Pressure)
                {
                    case "Low":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Blue.Default};")>Low</MudChip>
                        break;
                    case "High":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Red.Default};")>High</MudChip>
                        break;
                    case "Normal":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Green.Default};")>Normal</MudChip>
                        break;
                }

            </MudTd>
        }
        @if (PlanetSearchState.ShowTemperature)
        {
            <MudTd DataLabel="Temp">
                @switch (context.Temperature)
                {
                    case "Low":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Blue.Default};")>Low</MudChip>
                        break;
                    case "High":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Red.Default};")>High</MudChip>
                        break;
                    case "Normal":
                        <MudChip Size="Size.Small" Variant="Variant.Filled" Style=@($"background-color:{Colors.Green.Default};")>Normal</MudChip>
                        break;
                }

            </MudTd>
        }
        @if (PlanetSearchState.ShowLM)
        {
            <MudTd DataLabel="LM">
                <MudCheckBox Dense="true" Value="@context.HasLocalMarket" ReadOnly="true" />
            </MudTd>
        }
        @if (PlanetSearchState.ShowWAR)
        {
            <MudTd DataLabel="WAR">
                <MudCheckBox Dense="true" Value="@context.HasWarehouse" ReadOnly="true" />
            </MudTd>
        }
        @if (PlanetSearchState.ShowADM)
        {
            <MudTd DataLabel="ADM">
                <MudCheckBox Dense="true" Value="@context.HasAdministrationCenter" ReadOnly="true" />
            </MudTd>
        }
        @if (PlanetSearchState.ShowSHY)
        {
            <MudTd DataLabel="SHY">
                <MudCheckBox Dense="true" Value="@context.HasShipyard" ReadOnly="true" />
            </MudTd>
        }
        @if (PlanetSearchState.ShowCOGC)
        {
            <MudTd DataLabel="COGC">
                <MudCheckBox Dense="true" Value="@context.HasChamberOfCommerce" ReadOnly="true" />
            </MudTd>

            <MudTd DataLabel="COGC Program">
                @context.ActiveCOGCDisplay
            </MudTd>
        }
        @for (int ExchangeIdx = 0; ExchangeIdx < ExchangeLocationNames.Count; ++ExchangeIdx)
        {
            var i = ExchangeIdx; // Capture
            var ExchangeJumpCount = PlanetSearchState.ShowExchangeJumps.Count;
            @if (i < ExchangeJumpCount && PlanetSearchState.ShowExchangeJumps[i])
            {
                <MudTd DataLabel="@(ExchangeLocationNames[i])">
                    @if (context.DistanceResults.Count > i)
                    {
                        @(context.DistanceResults[i] != -1 ? $"{context.DistanceResults[i]}" : "")
                    }
                </MudTd>
            }
        }
        @if (PlanetSearchState.ShowCurrency)
        {
            <MudTd DataLabel="Currency">
                @context.CurrencyCode
            </MudTd>
            
        }
        @if (PlanetSearchState.ShowTotalPioneers)
        {
            <MudTd DataLabel="Total Pioneers">
                @context.TotalPioneers
            </MudTd>
        }
        @if (PlanetSearchState.ShowUnemployedPioneers)
        {
            <MudTd DataLabel="Unemployed Pioneers">
                @context.OpenPioneers
            </MudTd>
        }
        @if (PlanetSearchState.ShowTotalSettlers)
        {
            <MudTd DataLabel="Total Settlers">
                @context.TotalSettlers
            </MudTd>
        }
        @if (PlanetSearchState.ShowUnemployedSettlers)
        {
            <MudTd DataLabel="Unemployed Settlers">
                @context.OpenSettlers
            </MudTd>
        }
        @if (PlanetSearchState.ShowTotalTechnicians)
        {
            <MudTd DataLabel="Total Technicians">
                @context.TotalTechnicians
            </MudTd>
        }
        @if (PlanetSearchState.ShowUnemployedTechnicians)
        {
            <MudTd DataLabel="Unemployed Technicians">
                @context.OpenTechnicians
            </MudTd>
        }
        @if (PlanetSearchState.ShowTotalEngineers)
        {
            <MudTd DataLabel="Total Engineers">
                @context.TotalEngineers
            </MudTd>
        }
        @if (PlanetSearchState.ShowUnemployedEngineers)
        {
            <MudTd DataLabel="Unemployed Engineers">
                @context.OpenEngineers
            </MudTd>
        }
        @if (PlanetSearchState.ShowTotalScientists)
        {
            <MudTd DataLabel="Total Scientists">
                @context.TotalScientists
            </MudTd>
        }
        @if (PlanetSearchState.ShowUnemployedScientists)
        {
            <MudTd DataLabel="Unemployed Scientists">
                @context.OpenScientists
            </MudTd>
        }
        @if (PlanetSearchState.ShowTotalPlots)
        {
            <MudTd DataLabel="Total Plots">
                @context.TotalPlots
            </MudTd>
        }
    </RowTemplate>
    <PagerContent>
        <MudTablePager PageSizeOptions="new int[] { 50, 100, 500, int.MaxValue }" />
    </PagerContent>
</MudTable>